Index: /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/EsGriewankSampleTest.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/EsGriewankSampleTest.cs	(revision 17655)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/EsGriewankSampleTest.cs	(revision 17656)
@@ -66,5 +66,4 @@
       problem.Dimension = 10;
       problem.TestFunction = new Griewank();
-      problem.Encoding.SolutionCreator = new UniformRandomRealVectorCreator();
       problem.Bounds = new DoubleMatrix(new double[,] { { -600, 600 } });
       problem.BestKnownQuality = 0;
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/LocalSearchKnapsackSampleTest.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/LocalSearchKnapsackSampleTest.cs	(revision 17655)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/LocalSearchKnapsackSampleTest.cs	(revision 17656)
@@ -63,5 +63,4 @@
       problem.BestKnownSolution = new HeuristicLab.Encodings.BinaryVectorEncoding.BinaryVector(new bool[] { 
        true , false, false, true , true , true , true , true , false, true , true , true , true , true , true , false, true , false, true , true , false, true , true , false, true , false, true , true , true , false, true , true , false, true , true , false, true , false, true , true , true , true , true , true , true , true , true , true , true , true , true , false, true , false, false, true , true , false, true , true , true , true , true , true , true , true , false, true , false, true , true , true , true , false, true , true , true , true , true , true , true , true});
-      problem.Encoding.SolutionCreator = new RandomBinaryVectorCreator();
       problem.KnapsackCapacity = 297;
       problem.Values = new IntArray(new int[] { 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/OSESGriewankSampleTest.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/OSESGriewankSampleTest.cs	(revision 17655)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/OSESGriewankSampleTest.cs	(revision 17656)
@@ -65,5 +65,4 @@
       problem.Dimension = 10;
       problem.TestFunction = new Griewank();
-      problem.Encoding.SolutionCreator = new UniformRandomRealVectorCreator();
       problem.Bounds = new DoubleMatrix(new double[,] { { -600, 600 } });
       problem.BestKnownQuality = 0;
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/PsoRastriginSampleTest.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/PsoRastriginSampleTest.cs	(revision 17655)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/PsoRastriginSampleTest.cs	(revision 17656)
@@ -25,5 +25,4 @@
 using HEAL.Attic;
 using HeuristicLab.Algorithms.ParticleSwarmOptimization;
-using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Problems.TestFunctions;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
@@ -69,5 +68,4 @@
       var provider = new SOTFInstanceProvider();
       problem.Load(provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name == "Rastrigin Function")));
-      problem.Encoding.SolutionCreator = new UniformRandomRealVectorCreator();
       #endregion
       #region Algorithm Configuration
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SimulatedAnnealingRastriginSampleTest.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SimulatedAnnealingRastriginSampleTest.cs	(revision 17655)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SimulatedAnnealingRastriginSampleTest.cs	(revision 17656)
@@ -63,5 +63,4 @@
       problem.TestFunction= new Rastrigin();
       problem.Dimension = 2;
-      problem.Encoding.SolutionCreator = new UniformRandomRealVectorCreator();
       #endregion
       #region Algorithm Configuration